CREATE TABLE func_update_topic_status(
    change_id INTEGER NOT NULL,
    id INTEGER NOT NULL,
    status VARCHAR(40),
    rank INTEGER,
    def INTEGER
);

CREATE TRIGGER
    func_update_topic_status_bi_1
BEFORE INSERT ON
    func_update_topic_status
FOR EACH ROW BEGIN

    SELECT debug(
        NEW.change_id,
        NEW.id,
        NEW.status,
        NEW.rank,
        NEW.def
    );

    INSERT INTO
        topic_status_deltas(
            id,
            topic_status_id,
            status,
            rank,
            def
        )
    VALUES(
        NEW.change_id,
        NEW.id,
        NEW.status,
        NEW.rank,
        NEW.def
    );

    SELECT RAISE(IGNORE);

END;
